
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Funding_sourcesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const funding_sources = await db.funding_sources.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        source_type: data.source_type
        ||
        null
            ,
            
        reference_code: data.reference_code
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        total_committed_amount: data.total_committed_amount
        ||
        null
            ,
            
        effective_date: data.effective_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await funding_sources.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return funding_sources;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const funding_sourcesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                source_type: item.source_type
            ||
            null
            ,
            
                reference_code: item.reference_code
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                total_committed_amount: item.total_committed_amount
            ||
            null
            ,
            
                effective_date: item.effective_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const funding_sources = await db.funding_sources.bulkCreate(funding_sourcesData, { transaction });

        // For each item created, replace relation files
        

        return funding_sources;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const funding_sources = await db.funding_sources.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.source_type !== undefined) updatePayload.source_type = data.source_type;
        
        
        if (data.reference_code !== undefined) updatePayload.reference_code = data.reference_code;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.total_committed_amount !== undefined) updatePayload.total_committed_amount = data.total_committed_amount;
        
        
        if (data.effective_date !== undefined) updatePayload.effective_date = data.effective_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await funding_sources.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await funding_sources.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return funding_sources;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const funding_sources = await db.funding_sources.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of funding_sources) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of funding_sources) {
                await record.destroy({transaction});
            }
        });


        return funding_sources;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const funding_sources = await db.funding_sources.findByPk(id, options);

        await funding_sources.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await funding_sources.destroy({
            transaction
        });

        return funding_sources;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const funding_sources = await db.funding_sources.findOne(
            { where },
            { transaction },
        );

        if (!funding_sources) {
            return funding_sources;
        }

        const output = funding_sources.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.budget_programs_funding_source = await funding_sources.getBudget_programs_funding_source({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.programs_funding_source = await funding_sources.getPrograms_funding_source({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await funding_sources.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'funding_sources',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.reference_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'funding_sources',
                        'reference_code',
                        filter.reference_code,
                    ),
                };
            }
            

            
            

            
            if (filter.total_committed_amountRange) {
                const [start, end] = filter.total_committed_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_committed_amount: {
                    ...where.total_committed_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_committed_amount: {
                    ...where.total_committed_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.effective_dateRange) {
                const [start, end] = filter.effective_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_date: {
                    ...where.effective_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_date: {
                    ...where.effective_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source_type) {
                where = {
                    ...where,
                source_type: filter.source_type,
            };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.funding_sources.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'funding_sources',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.funding_sources.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

